## freedup-1.6-3-src.tar.bz2

=== Makefile ===
#!/usr/bin/make -f
#
# This file is part of FreeDup.
#
#    FreeDup -- search for duplicate files in one or more directory hierarchies
#    Copyright (C) 2007,2008 Andreas Neuper
#
#    FreeDup is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    Foobar is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with FreeDup.  If not, see <http://www.gnu.org/licenses/>.
#
SUFFIX=.gz .bz2 .tar.bz2 .tgz .tar .lint
.PHONY: distclean clean rpm hashtest tarball test

#
# OS specific definitions
#
#the following two lines will most likely fail for non-GNU make
#in this case please replace the lines by the contents of the included file
include Makefile.$(shell uname -s)
HTML2TEXT = /usr/bin/html2text
CFLAGS=-g3 -Wall -pedantic -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64 $(DEFS) -std=gnu99 -O0
CFLAGS=-O2 -Wall -pedantic -D_LARGEFILE_SOURCE -D_LARGEFILE64_SOURCE -D_FILE_OFFSET_BITS=64 $(DEFS) -std=gnu99

#
# PREFIX indicates directory tree where program is to be installed.
# Suggested values are "/usr/local" or "/usr".
# The variable used for execution ist DESTDIR only (needed by debian)
#
INSTALL = install
INSTALLDIR = /
PREFIX = /usr
BINDIR = $(PREFIX)/bin
LIBDIR = $(PREFIX)/lib
MANDIR = $(PREFIX)/share/man
INSTBINMODE = 755
INSTDOCMODE = 755
INSTALLOWN = root
INSTALLGRP = root
DESTDIR=$(INSTALLDIR)


#
# VERSION determines the program's version number.
#
VERSION = "$$(/bin/cat version)"
MAKFILES= Makefile Makefile.tests Makefile.Linux Makefile.Darwin \
	  Makefile.CYGWIN_NT-5.1 Makefile.AIX Makefile.BSD
SRCFILES= freedup.c freedup.h sha1.c sha1.h config.c config.h \
	  my.c mp3.c mp4.c mpc.c jpg.c ogg.c auto.c \
	  my.h mp3.h mp4.h mpc.h jpg.h ogg.h auto.h \
	  web.c web.h socket.c socket.h helper.h nethelp.h \
	  symharden.c
TARFILES= $(MAKFILES) demo $(SRCFILES) README.SHA README.html COPYING.SHA \
	  freedup freedup.1 freedup.spec freedup.xinetd symharden symharden.1 \
	  ChangeLog TODO README COPYING rules copyright verify pad.xml debian
HTMLFILES=intro.html syntax.html download.html process.html \
	  examples.html hint.html questions.html offer.html
DOCFILES= freedup.css index.html foot.html head.html $(HTMLFILES)
OBJFILES= freedup.o config.o sha1.o mp3.o mp4.o mpc.o jpg.o my.o ogg.o auto.o web.o socket.o 

#
# ALL that needs/should be done
#
all:	freedup test

tags:	$(SRCFILES)
	ctags $(SRCFILES)
#
# ALL that needs/should be done
#
test:	Makefile.tests stest
	$(MAKE) -f $<

stest: hashtest	shatest

verify:	Makefile Makefile.$(shell uname -s)
	@echo "#!$$(which make) -f " >verify
	@sed "s:./freedup:$(DESTDIR)/freedup:" Makefile.$(shell uname -s) >>verify
	@sed -e '/^include/d' -e 's/:[ 	]*freedup/:/' Makefile.tests >>verify
	@chmod a+x verify

#
# INSTALLATION without using RPM
#
install: freedup freedup.1.gz symharden symharden.1.gz
	[ "./freedup" = $(FREEDUPEXE) ] || cp $(FREEDUPEXE) freedup
	$(INSTALL) -d $(DESTDIR)
	$(INSTALL) -d $(DESTDIR)/$(BINDIR)
	$(INSTALL) -p -s -m $(INSTBINMODE) freedup   $(DESTDIR)/$(BINDIR)/freedup
	$(INSTALL) -p -s -m $(INSTBINMODE) symharden $(DESTDIR)/$(BINDIR)/symharden
	$(INSTALL) -d $(DESTDIR)/$(MANDIR)/man1
	$(INSTALL) -p -m $(INSTDOCMODE) freedup.1.gz   $(DESTDIR)/$(MANDIR)/man1/
	$(INSTALL) -p -m $(INSTDOCMODE) symharden.1.gz $(DESTDIR)/$(MANDIR)/man1/

#
# FREEDUP direct dependencies
#
freedup.o: freedup.c freedup.h version.h mp3.h jpg.h my.h ogg.h
freedup: $(OBJFILES)


#
# VERSION is now only specified in freedup.spec
# this action generates a reliable "version" file
# that will be used troughout this package
#
version: freedup.spec
	awk '{if($$1=="%define"){if($$2=="version")v=$$3;if($$2=="release")r=$$3;}};END{printf"%s-%s",v,r;}' \
	freedup.spec >version

version.h: version
	$(ECHOE) "#define VERSION\t\"$$(/bin/cat version)\"" >version.h

#
# An attempt to produce a single file documentation
#
README.html: head.html $(DOCFILES)
	-@rm -f $@
	sed -n '1,/<.BODY>/p' head.html >$@
	for n in $(HTMLFILES); do \
	sed -n '/<BODY/,/<.BODY>/p' $$n | grep -v 'BODY' >>$@ ; done
	$(ECHOE) "</BODY>\n</HTML>">>$@

README:	README.html
	@echo "Converting $< into a plain text file called $@."
	@if [ -x $(HTML2TEXT) ] ; then \
	$(ECHOE) " FFFFF RRRRR   EEEEE  EEEEE  DDDD   UU UU  PPPPP" >$@ ;\
	$(ECHOE) " FF    RR  RR  EE     EE     DD DD  UU UU  PP  PP" >>$@ ;\
	$(ECHOE) " FFFF  RRRR    EEEEE  EEEEE  DD DD  UU UU  PPPPP" >>$@ ;\
	$(ECHOE) " FF    RR RR   EE     EE     DD DD  UU UU  PP" >>$@ ;\
	$(ECHOE) " FF    RR  RR  EEEEE  EEEEE  DDDD    UUU   PP" >>$@ ;\
	$(HTML2TEXT) -nobs $< |\
	sed -e '1,3d' -e '5s:FREEDUP *::' -e '6s: :
- :g' \
	    -e 's:\*\{5\}\(.*\)\*\{5\}:
#####
#####
#####    \1
#####
#####
:' \
	    -e 's:\*\{4\}\(.*\)\*\{4\}:
\*\*\*\*\*
\*\*\*\*\* \1
\*\*\*\*\*
:' |\
	tr '\015' '\012' >> $@ ;\
	else echo "see README.html">$@ ;fi

changelog: freedup.spec version
	(echo "freedup ($$(/bin/cat version)) unstable; urgency=low"; echo) >changelog
	@sed -n '/^%changelog/,$$p' freedup.spec | grep -v '^%changelog' |\
	awk '{if($$1=="*")author="\n -- "$$6" "$$7" "$$8"  "$$2", "$$4" "$$3" "$$5" 06:00:00 +0100\n"; if($$1=="-" || $$1=="+") print " "$$0"."; if(NF==0){print author}}' |\
	sed -e 's: - :  * :g'>>changelog

ChangeLog: freedup.spec
	sed -n '/^%changelog/,$$p' freedup.spec | grep -v '^%changelog' >ChangeLog


pad.xml: pad.xms
	@sed -e s:VERSION:$$(/bin/cat version): -e s=VERYEAR=$$(date +%Y)= -e s=VERMONTH=$$(date +%m)= -e s=VERDAY=$$(date +%d)= -e s=VERSIZE=$$(ls -l attic/freedup-$$(/bin/cat version)-src.tar.bz2 | awk '{print $$5}')= -e s=VERKSIZE=$$(ls -l attic/freedup-$$(/bin/cat version)-src.tar.bz2 | awk '{printf"%d",$$5/1024}')= -e s=VERMSIZE=$$(ls -l attic/freedup-$$(/bin/cat version)-src.tar.bz2 | awk '{printf"%3.3f",$$5/1024/1024}')= $< >$@

#
# automatically generate all published file formats
#
%.tar.bz2:	%.tgz
	gzip -cd $< | bzip2 -c >$@

%.tgz:	%.tar.bz2
	bzip2 -cd $< | gzip -c >$@

%.html:	html/%.html
	ln $< $@

%.css:	html/%.css
	ln $< $@

%.gz:	%
	gzip -c $< >$@

%.html: %
	@echo "Generating $@ from plain text file $<."
	@($(ECHOE) "<?XML version=\"1.0\" encoding=\"utf-8\"?>\n<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\"  \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n<HTML lang=\"en\" xml:lang=\"en\" xmlns=\"http://www.w3.org/1999/xhtml\">\n<HEAD>\n<TITLE>Freedup $< </TITLE>\n<META HTTP-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\" />\n<META NAME=\"KEYWORDS\" content=\"Freedup, systems management, tool, link, $<\" />\n<META HTTP-EQUIV=\"expires\" content=\"Fri, 31 Dec 2010 19:00:00 CET\" />\n<LINK REL=\"stylesheet\" type=\"text/css\" href=\"freedup.css\" />\n</HEAD>\n<BODY BGCOLOR=\"#DDDDFF\">\n<PRE>" ; sed -e 's:^$$:</PRE><P><PRE>:' $< ; $(ECHOE) "</PRE>\n</BODY>\n</HTML>") >$@

#
# generate the setup.hint file for CYGWIN automatically
#
SDESC=reduces used disk space by linking duplicate files while being able to ignore tags.
LDESC=Freedup finds and eliminates duplicate files by linking them (aka deduplication), and thus reduces the amount of used disk space within one or more file systems. By default, hardlinks are used on a single device, symbolic links when the devices differ. A set of options allows you to modify the methods of file comparison, the hash functions, the linking behavior, and the reporting style. You may use batch or interactive mode. Freedup usually only considers identical files, but when comparing audio or graphics files, you may elect to ignore the tags.

setup.hint: $(MAKFILES) version freedup.spec
	@echo "# This file is generated by make" >setup.hint
	@echo "category: System Utils" >>setup.hint
	@echo "requires: cygwin" >>setup.hint
	@echo "sdesc: Freedup $(SDESC)" >>setup.hint
	@echo "ldesc: $(LDESC)" >>setup.hint
	@echo "curr: $$(/bin/cat version)" >>setup.hint

DEBIAN=	control compat changelog
#debian: $(DEBIAN) rules copyright
#	@mkdir -p $@
#	mv $(DEBIAN) $@
#	cp rules copyright $@
#	dpkg-buildpackage -d
#
#control:
#	@echo "Source: freedup" >control
#	@echo "Section: utils" >>control
#	@echo "Priority: optional" >>control
#	@echo "Maintainer: AN <AN@freedup.org>" >>control
#	@echo "Build-Depends: debhelper (>= 3.0.0)" >>control
#	@echo "Standards-Version: 3.5.2" >>control
#	@echo "" >>control
#	@echo "Package: freedup" >>control
#	@echo 'Depends: $${shlibs:Depends}, $${misc:Depends}' >>control
#	@echo "Architecture: $$(uname -i)" >>control
#	@echo "Description: $(SDESC)" >>control
#	@echo " $(LDESC)" >>control
#
#compat:
#	echo "4" >compat

#
# generate the distribution tarballs
# (avoid calling this - use make rpm instead)
#
tarball:	freedup version README ChangeLog $(TARFILES)
	[ "./freedup" = $(FREEDUPEXE) ] || cp $(FREEDUPEXE) freedup
	strip freedup
	if [ -d freedup-$$(/bin/cat version|tr - -) ] ; then exit -1 ;fi
	mkdir freedup-$$(/bin/cat version|tr - -)
	cp -r $(TARFILES) freedup-$$(/bin/cat version|tr - -)
	mkdir freedup-$$(/bin/cat version|tr - -)/html
	cp $(DOCFILES) freedup-$$(/bin/cat version|tr - -)/html
	tar czf freedup-$$(/bin/cat version)-orig.tar.gz \
	freedup-$$(/bin/cat version|tr - -)
	tar cjf freedup-$$(/bin/cat version)-src.tar.bz2 \
	freedup-$$(/bin/cat version|tr - -)
	ln freedup-$$(/bin/cat version)-orig.tar.gz \
	freedup_$$(/bin/cat version|cut -d- -f1).orig.tar.gz
	@echo "\n---Debian systems may fail during the next steps---\n\n"
	-[ -d $(RPMBUILD)/SOURCES ] &&	\
	tar cjf $(RPMBUILD)/SOURCES/freedup-$$(/bin/cat version)-src.tar.bz2 \
	freedup-$$(/bin/cat version|tr - -)
	-[ -d $(RPMBUILD)/SOURCES ] &&	\
	tar czf $(RPMBUILD)/SOURCES/freedup-$$(/bin/cat version)-src.tgz \
	freedup-$$(/bin/cat version|tr - -)

#
# generate the own distribution RPM file
#
rpm:	tarball verify
	rpmbuild -ba --sign freedup.spec
	cp $(RPMBUILD)/RPMS/i586/freedup-$$(/bin/cat version)* .
	cp $(RPMBUILD)/SRPMS/freedup-$$(/bin/cat version)* .

#
# switching gui mode on and off
#
webon:	
	-@[ -f /etc/services ] && $$(grep -q freedup /etc/services) || echo -e "freedup\t\t31166/tcp" >>//etc/services
	-@[ -f /etc/inetd.conf ] && $$(grep -q freedup /etc/inetd.conf) || echo "freedup stream  tcp nowait root /usr/bin/freedup freedup -W" >>/etc/inetd.conf
	-@[ -f /etc/inetd.conf ] && $$(grep -q freedup /etc/inetd.conf) && cp /etc/inetd.conf /tmp && sed 's:^.*freedup.*stream:freedup stream:' /tmp/inetd.conf >/etc/inetd.conf && rm /tmp/inetd.conf
	-@[ -d /etc/xinetd.d -a ! -f /etc/xinetd.d/freedup ] && echo "service freedup\n{\n\tport\t= 31166\n\tsocket_type\t= stream\n\tprotocol\t= tcp\n\twait\t= no\n\tuser\t= root\n\tdisable\t= no\n\tserver\t= /home/aneuper/src/freedup/freedup\n\tserver_args\t= -W\n}" >>/etc/xinetd.d/freedup && chmod 644 /etc/xinetd.d/freedup || echo  -e '\c'
	-@[ -d /etc/xinetd.d -a -f /etc/xinetd.d/freedup ] && mv /etc/xinetd.d/freedup /tmp/freedup.off && sed 's:disable.*:disable\t= no:' /tmp/freedup.off >/etc/xinetd.d/freedup && chmod 644 /etc/xinetd.d/freedup

weboff:
	-@[ -f /etc/services ] && $$(grep -q freedup /etc/services) || echo -e "freedup\t\t31166/tcp" >>//etc/services
	-@[ -d /etc/xinetd.d -a -f /etc/xinetd.d/freedup ] && mv  /etc/xinetd.d/freedup /tmp/freedup.on && sed 's:disable.*:disable\t= yes:' /tmp/freedup.on >/etc/xinetd.d/freedup && chmod 644 /etc/xinetd.d/freedup && rm /tmp/freedup.on
	-@[ -f /etc/inetd.conf ] && $$(grep -q freedup /etc/inetd.conf) && cp /etc/inetd.conf /tmp && sed 's:^.*freedup.*stream:# freedup stream:' /tmp/inetd.conf >/etc/inetd.conf && rm /tmp/inetd.conf

state:

=== debian/changelog ===
freedup (1.6-3) unstable; urgency=low
   
  * Initial raspberry distribution (Closes ITA: #nnnn)
    Tue Mar 04 2011 devel (AN) <AN@freedup.org>
  * Bugfixes in version 1.6-3
    + fixed compile errors for cygwin in socket.c (Feb 08 2011)
    + fixed compile error for raspberry in freedup.c (Mar 04 2014)
  * Added Manpage for SymHarden
    + includes minor corrections to FreeDup Manpage
   
 -- AN <AN@freedup.org>  Wed, 05 Mar 2014 03:20:14 +0000
   

freedup (1.6-2) unstable; urgency=low

   * Thu Feb 04 2011 devel (AN) <AN@freedup.org>
   - Bugfixes in version 1.6-2
     + replaced softlink to symharden.c
   
   * Thu Jan 11 2011 devel (AN) <AN@freedup.org>
   - Changes to version 1.6-1
     + signal handler catches CTRL-C to free duplicates discovered so far
     + added if-defines to avoid double parsing of *.h files
     + removed inline directive [due to compile errors by request of Andres Meyer]
   - Enhancement in version 1.6-1
     + added listener interface
     + added new platform makefile for Apple Mac Version 10.6.0 i386 [tested]
     + catch filesystem errors (e.g. /sys) and print warnings instead of assertions
     + added (sp)lint rule for linux
     + added symharden tool to convert softlinks into hardlinks whereever possible
   - Bugfixes in version 1.6-1
     + added missing #ifdef HASHSUM statements [notified by Linc Davis]
     + using include of <sys/stat.h> instead of <linux/stat.h> [by Linc Davis]
     + added fclose() to mp4.c and checking all fclose()/fseek() result codes
     + linted mp3.c, mp4.c mpc.c, auto.c, ogg.c, jpg.c and my.c
     + partially linted freedup.c (e.g. splint does not fail anymore)
     + moved filesize variables in "extra" functions from size_t=int to ulong
     + incorporated patch to avoid segfaults [by Charles Duppy]
   - Known Bug in 1.6-1
     + Apple Mac version does not link different ownerships (yet reason unclear)
   
   * Thu Mar 06 2008 devel (AN) <AN@freedup.org>
   - Changes to unpublished version 1.5-4
     + Corrected Copyright statements to comply with OSF (GPL) requirements
   - Enhancement in unpublished version 1.5-4
     + minor corrections to man page
   
   * Thu Mar 06 2008 devel (AN) <AN@freedup.org>
   - Changes to version 1.5-3
     + gui defaults to off, activate and deactivate using "make webon/weboff/state"
   
   * Thu Mar 06 2008 devel (AN) <AN@freedup.org>
   - Changes to version 1.5-3
     + the features provided with option -W are for testing purpose only
     + basic web interface offered (reply not accepted yet)
     + changed invisible default option for sorting criteria to '.'
   - Enhancement in version 1.5-3
     + automated installation routine for xinetd and inetd
     + deinstall script for xinetd only
     + added html pages to rpm package as well
   - Bugfixes in version 1.5-3
     + removed a leftover debug command
   
   * Sun Mar 02 2008 devel (AN) <AN@freedup.org>
   - Enhancement in version 1.5-2
     + enable freedup to restore directory time stamp after linking (option -T)
     + added usage help, man page and syntax web page for option -T
     + extended test3 in Makefile.tests to check new option -T
     + streamlined Makefile.tests using for-loops and 'test -ef'(25% reduced size)
     + Makefile.tests now needs gnu 'test' facility '[' to work correctly
   - Bugfixes in version 1.5-2
     + corrected date in copyright notice for -V
     + added '+' and '-' to -k option in online syntax help
   
   * Sat Feb 02 2008 devel (AN) <AN@freedup.org>
   - Enhancement in version 1.5-1
     + file trees are now scanned by an internal routine, find is called on demand
     + output during tree scanning changes every 1000 files (i.e. find activity)
     + updated man page to show how to use find instead of the internal routine
     + testing did not proof performance gain when using internal routine
   - Changes in version 1.5-1
     + first helper routines for web-based GUI
     + corrected and completed copyright information
   - Bugfixes in version 1.5-1
     + minor corrections to freedup man page
   
   * Mon Dec 31 2007 devel (AN) <AN@freedup.org>
   - Enhancement in version 1.4-4
     + report deleted files and the space saved (avail in interactive mode only)
     + link directions '+'/'-' allow to select source by size (extra style only)
   - Bugfixes in version 1.4-4
     + Makefile copies so that rpm cygwin executable is executable under cygwin
     + initialize all *source variables in dupinfo_entry() to avoid segfaults
     + do not offer linking when files already linked in interactive mode (w/o -H)
     + report linked files and bytes in interactive mode for extra styles
   
   * Fri Dec 28 2007 devel (AN) <AN@freedup.org>
   - Enhancement in version 1.4-3
     + one common routine to open config file (simplifies later extensions)
     + added routine to print existing environments in help (for a test period)
   - Bugfixes in version 1.4-3
     + use character instead of ascii code for '-k' in config file
     + finally fixed missing initialisation to avoid failing (n+m) assertion
     + if mp4 module is applied on mp3 files no more infinite loops should occur
   
   * Mon Dec 24 2007 devel (AN) <AN@freedup.org>
   - Enhancement in version 1.4-2
     + there are no more restrictions on the number of identical files
     + added '-H' for the same use as in fdupes: show hardlinked files too
     + added man page description for '-k' and '-H'
   - Bugfixes in version 1.4-2
     + improved test routine for MP3 and JPG Mix
     + added new line before printing statistics
     + stop printing interactive selection list, when there are no more letters
   
   * Sat Dec 21 2007 devel (AN) <AN@freedup.org>
   - Enhancement in version 1.4-1
     + '-k' option changed and recognized key pattern (same key as interactive)
     + '-ni' now reports reliable predictions on linked files and bytes
     + '-n' is reported (and indicated) to report to much for multiple links.


=== debian/control ===
Source: freedup
Section: utils
Priority: extra
Maintainer: AN <AN@freedup.org>
Build-Depends: debhelper (>= 8.0.0)
Standards-Version: 3.9.3
Homepage: http://www.freedup.org/

Package: freedup
Depends: ${shlibs:Depends}, ${misc:Depends}
Architecture: any
Description: reduces disk usage by linking duplicate files while being able to ignore tags
 Freedup finds and eliminates duplicate files by linking them (aka deduplication), and thus reduces the amount of used disk space within one or more file systems. By default, hardlinks are used on a single device, symbolic links when the devices differ. A set of options allows you to modify the methods of file comparison, the hash functions, the linking behavior, and the reporting style. You may use batch or interactive mode. Freedup usually only considers identical files, but when comparing audio or graphics files, you may elect to ignore the tags.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
export DEB_BUILD_HARDENING=1

%:
	dh $@

=== debian/watch ===
version=3
http://www.freedup.org/freedup-(.+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
